const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_photos = sequelize.define(
    'user_photos',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

sort_order: {
        type: DataTypes.INTEGER,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

uploaded_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_photos.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
























    db.user_photos.hasMany(db.content_moderation_items, {
      as: 'content_moderation_items_photo',
      foreignKey: {
          name: 'photoId',
      },
      constraints: false,
    });





//end loop



    db.user_photos.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });



    db.user_photos.hasMany(db.file, {
      as: 'photo',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.user_photos.getTableName(),
        belongsToColumn: 'photo',
      },
    });


    db.user_photos.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_photos.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_photos;
};


